; The CMD file.
;-| Button Remapping |-----------------------------------------------------
[Remap]
x = x
y = y
z = z
a = a
b = b
c = c
s = s

;-| Default Values |-------------------------------------------------------
[Defaults]
; Default value for the "time" parameter of a Command. Minimum 1.
command.time = 15

; Default value for the "buffer.time" parameter of a Command. Minimum 1,
; maximum 30.
command.buffer.time = 1


;-| Super Motions |--------------------------------------------------------

[Command]
name = "QCF_PP"
command = ~D, DF, F, x+y
time = 20

[Command]
name = "QCF_PP"
command = ~D, DF, F, x+z
time = 20

[Command]
name = "QCF_PP"
command = ~D, DF, F, y+z
time = 20

[Command]
name = "HCB_PP"
command = ~F, D, B, x+y
time = 20

[Command]
name = "HCB_PP"
command = ~F, D, B, x+z
time = 20

[Command]
name = "HCB_PP"
command = ~F, D, B, y+z
time = 20

;-| Special Motions |------------------------------------------------------
[Command]
name = "upper_x"
command = ~F, D, DF, x

[Command]
name = "upper_y"
command = ~F, D, DF, y

[Command]
name = "upper_z"
command = ~F, D, DF, z

[Command]
name = "QCF_x"
command = ~D, DF, F, x

[Command]
name = "QCF_y"
command = ~D, DF, F, y

[Command]
name = "QCF_z"
command = ~D, DF, F, z

[Command]
name = "HCB_x"
command = ~F, D, B, x

[Command]
name = "HCB_y"
command = ~F, D, B, y

[Command]
name = "HCB_z"
command = ~F, D, B, z

;-| Double Tap |-----------------------------------------------------------
[Command]
name = "FF"     ;Required (do not remove)
command = F, F
time = 10

[Command]
name = "BB"     ;Required (do not remove)
command = B, B
time = 10

;-| 2/3 Button Combination |-----------------------------------------------
[Command]
name = "recovery";Required (do not remove)
command = x+y
time = 1

[Command]
name="assist"
command=y+b
time=1

[Command]
name="tag"
command=z+c
time=1

[Command]
name="guardpush"
command=x+y
time=1

[Command]
name="guardpush"
command=x+z
time=1

[Command]
name="guardpush"
command=y+z
time=1


;-| Dir + Button |---------------------------------------------------------
[Command]
name = "down_a"
command = /$D,a
time = 1

[Command]
name = "down_b"
command = /$D,b
time = 1

;-| Single Button |---------------------------------------------------------
[Command]
name = "a"
command = a
time = 1

[Command]
name = "b"
command = b
time = 1

[Command]
name = "c"
command = c
time = 1

[Command]
name = "x"
command = x
time = 1

[Command]
name = "y"
command = y
time = 1

[Command]
name = "z"
command = z
time = 1

[Command]
name = "start"
command = s
time = 1

;-| Hold Dir |--------------------------------------------------------------
[Command]
name = "holdfwd";Required (do not remove)
command = /$F
time = 1

[Command]
name = "holdback";Required (do not remove)
command = /$B
time = 1

[Command]
name = "holdup" ;Required (do not remove)
command = /$U
time = 1

[Command]
name = "holddown";Required (do not remove)
command = /$D
time = 1

;---------------------------------------------------Super Jump

[Command]
name = "DU"
command = $D, $U
time = 10

;-| Dir |-------------------------------------------------------------------

[command]
name="fwd"
command=F
time=1

[command]
name="back"
command=B
time=1

[command]
name="up"
command=U
time=1

[command]
name="down"
command=D
time=1


;---------------------------------------------------------------------------
; 2. State entry
; --------------
; This is where you define what commands bring you to what states.
;
; Each state entry block looks like:
;   [State -1, Label]           ;Change Label to any name you want to use to
;                               ;identify the state with.
;   type = ChangeState          ;Don't change this
;   value = new_state_number
;   trigger1 = command = command_name
;   . . .  (any additional triggers)
;
; - new_state_number is the number of the state to change to
; - command_name is the name of the command (from the section above)
; - Useful triggers to know:
;   - statetype
;       S, C or A : current state-type of player (stand, crouch, air)
;   - ctrl
;       0 or 1 : 1 if player has control. Unless "interrupting" another
;                move, you'll want ctrl = 1
;   - stateno
;       number of state player is in - useful for "move interrupts"
;   - movecontact
;       0 or 1 : 1 if player's last attack touched the opponent
;                useful for "move interrupts"
;
; Note: The order of state entry is important.
;   State entry with a certain command must come before another state
;   entry with a command that is the subset of the first.
;   For example, command "fwd_a" must be listed before "a", and
;   "fwd_ab" should come before both of the others.
;
; For reference on triggers, see CNS documentation.
;
; Just for your information (skip if you're not interested):
; This part is an extension of the CNS. "State -1" is a special state
; that is executed once every game-tick, regardless of what other state
; you are in.


; Don't remove the following line. It's required by the CMD standard.
[Statedef -1]

;---------------------------------------------------------------------------
;Triple Kung Fu Palm (uses one super bar)
;OJt[˂iQ[WxPj
[State -1, Hercules Rush]
type = ChangeState
value = 3000
triggerall = command = "QCF_PP"
triggerall = power >= 1000
triggerall = statetype != A
triggerall = movetype != H
triggerall = stateno != [3000,3100]
triggerall = stateno != [1200,1220]
trigger1 = ctrl
trigger2 = movecontact

;---------------------------------------------------------------------------
;Shinkuu Tatsumaki Senpukyaku (uses one super bar)
[State -1, Gigas Driver]
type = ChangeState
value = 3100
triggerall = command = "HCB_PP"
triggerall = power >= 1000
triggerall = statetype != A
triggerall = movetype != H
triggerall = stateno != [3000,3100]
triggerall = stateno != [1200,1220]
trigger1 = ctrl
trigger2 = movecontact

;===========================================================================
;This is not a move, but it sets up var(1) to be 1 if conditions are right
;for a combo into a special move (used below).
;Since a lot of special moves rely on the same conditions, this reduces
;redundant logic.
[State -1, Combo condition Reset]
type = VarSet
trigger1 = 1
var(1) = 0

[State -1, Combo condition Check]
type = VarSet
trigger1 = ctrl
trigger2 = (stateno = [200,299]) || (stateno = [400,499]) || (stateno = [600,699])
trigger2 = stateno != 440;Except for sweep kick
trigger2 = stateno != 215
trigger2 = stateno != 245
trigger2 = movecontact
var(1) = 1

;---------------------------------------------------------------------------
;Low Shoryuken
[State -1, Low Mars Slash]
type = ChangeState
value = 1100
triggerall = command = "upper_x"
triggerall = movetype != H
triggerall = statetype != A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
;Med Shoruken
[State -1, Medium Mars Slash]
type = ChangeState
value = 1110
triggerall = command = "upper_y"
triggerall = movetype != H
triggerall = statetype != A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
;Hard Shoryuken
[State -1, Hard Mars Slash]
type = ChangeState
value = 1120
triggerall = command = "upper_z"
triggerall = movetype != H
triggerall = statetype != A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Light Rush]
type = ChangeState
value = 1000
triggerall = command = "QCF_x"
triggerall = statetype!=A
triggerall = movetype != H
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Medium Rush]
type = ChangeState
value = 1010
triggerall = command = "QCF_y"
triggerall = statetype!=A
triggerall = movetype != H
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Hard Rush]
type = ChangeState
value = 1020
triggerall = command = "QCF_z"
triggerall = statetype!=A
triggerall = movetype != H
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Low Gaia Driver]
type = ChangeState
value = 1200
triggerall = command = "HCB_x"
triggerall = movetype != H
triggerall = statetype!=A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Medium Gaia Driver]
type = ChangeState
value = 1210
triggerall = command = "HCB_y"
triggerall = movetype != H
triggerall = statetype!=A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Hard Gaia Driver]
type = ChangeState
value = 1220
triggerall = command = "HCB_z"
triggerall = movetype != H
triggerall = statetype!=A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Air Low Gaia Driver]
type = ChangeState
value = 1250
triggerall = command = "HCB_x"
triggerall = movetype != H
triggerall = statetype=A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Air Medium Gaia Driver]
type = ChangeState
value = 1260
triggerall = command = "HCB_y"
triggerall = movetype != H
triggerall = statetype=A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;---------------------------------------------------------------------------
[State -1, Air Hard Gaia Driver]
type = ChangeState
value = 1270
triggerall = command = "HCB_z"
triggerall = movetype != H
triggerall = statetype=A
trigger1 = ctrl
trigger2 = var(1) ;Use combo condition (above)

;===========================================================================
;---------------------------------------------------------------------------
;Dash
[State -1, Dash]
type = ChangeState
value = 100
triggerall = stateno!=100 && stateno!=105
trigger1 = command = "FF"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Air Dash
[State -1, Air Dash]
type = ChangeState
value = 102
triggerall = command = "FF"
triggerall = statetype = A
triggerall = var(3) = 0
trigger1 = ctrl
trigger1 = PrevStateNo != 102

;---------------------------------------------------------------------------
;Step Back
[State -1, Step Back]
type = ChangeState
value = 105
triggerall = stateno!=100 && stateno!=105
trigger1 = command = "BB"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Air Dash
[State -1, Air Step Back]
type = ChangeState
value = 107
triggerall = command = "BB"
triggerall = statetype = A
triggerall = var(3) = 0
trigger1 = ctrl
trigger1 = PrevStateNo != 102

;---------------------------------------------------------------------------
[State -1, Zero Counter]
type = ChangeState
value = 750
triggerall = power >= 1000 && command = "tag"
triggerall = statetype != A
trigger1 = ctrl
trigger1 = (stateno = 150 || stateno = 151)

;---------------------------------------------------------------------------
[State -1, Guard Push stand]
type = ChangeState
value = 6300
triggerall = command = "guardpush" && statetype = S
trigger1 = stateno = [150,153]

[State -1, Guard Push crouch]
type = ChangeState
value = 6310
triggerall = command = "guardpush" && statetype = C
trigger1 = stateno = [150,153]

[State -1, Guard Push aerial]
type = ChangeState
value = 6320
triggerall = command = "guardpush" && statetype = A
trigger1 = stateno = [154,155]

;---------------------------------------------------------------------------
;Throw 1
[State -1, Throw 1]
type = ChangeState
value = 800
triggerall = command = "z"
triggerall = statetype = S
triggerall = ctrl
triggerall = stateno != 100
triggerall = command = "holdback" && command = "z" || command = "holdfwd" && command = "z"
trigger1 = p2bodydist X <= 30
trigger1 = p2statetype != A
trigger1 = p2movetype != H

;---------------------------------------------------------------------------
;Throw 1
[State -1, Throw 2]
type = ChangeState
value = 830
triggerall = command = "c"
triggerall = statetype = S
triggerall = ctrl
triggerall = stateno != 100
triggerall = command = "holdback" && command = "c" || command = "holdfwd" && command = "c"
trigger1 = p2bodydist X <= 30
trigger1 = p2statetype != A
trigger1 = p2movetype != H

;===========================================================================

;---------------------------------------------------------------------------
;Taunt
[State -1, Taunt]
type = ChangeState
value = 195
triggerall = command = "start"
trigger1 = statetype != A
trigger1 = ctrl


;---------------------------------------------------------------------------
;Stand Light Punch
[State -1, Stand Light Punch]
type = ChangeState
value = 200
triggerall = command = "x"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Stand Medium Punch
[State -1, Stand Medium Punch]
type = ChangeState
value = 210
triggerall = command = "y"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Stand Strong Punch
[State -1, Stand Strong Punch]
type = ChangeState
value = 220
triggerall = command = "z"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Stand Light Kick
[State -1, Stand Light Kick]
type = ChangeState
value = 230
triggerall = command = "a"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Standing Medium Kick
[State -1, Standing Medium Kick]
type = ChangeState
value = 240
triggerall = command = "b"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Standing Strong Kick
[State -1, Standing Strong Kick]
type = ChangeState
value = 250
triggerall = command = "c"
triggerall = command != "holddown"
trigger1 = statetype = S
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Light Punch
[State -1, Crouching Light Punch]
type = ChangeState
value = 400
triggerall = command = "x"
triggerall = command = "holddown"
triggerall = stateno != 400
trigger1 = statetype = C
trigger1 = ctrl
;trigger2 = stateno = 400 && AnimTime = 0

;---------------------------------------------------------------------------
;Crouching Medium Punch
[State -1, Crouching Medium Punch]
type = ChangeState
value = 410
triggerall = command = "y"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Strong Punch
[State -1, Crouching Strong Punch]
type = ChangeState
value = 420
triggerall = command = "z"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Light Kick
[State -1, Crouching Light Kick]
type = ChangeState
value = 430
triggerall = command = "a"
triggerall = command = "holddown"
triggerall = stateno != 430
trigger1 = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Strong Kick
[State -1, Crouching Strong Kick]
type = ChangeState
value = 440
triggerall = command = "b"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Crouching Strong Kick
[State -1, Crouching Strong Kick]
type = ChangeState
value = 450
triggerall = command = "c"
triggerall = command = "holddown"
trigger1 = statetype = C
trigger1 = ctrl

;---------------------------------------------------------------------------
;Jump Light Punch
[State -1, Jump Light Punch]
type = ChangeState
value = 600
triggerall = command = "x"
trigger1 = statetype = A
trigger1 = ctrl
trigger2 = stateno = 1350 ;Air blocking

;---------------------------------------------------------------------------
;Jump Strong Punch
[State -1, Jump Strong Punch]
type = ChangeState
value = 610
triggerall = command = "y"
trigger1 = statetype = A
trigger1 = ctrl
;trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
;trigger2 = movecontact
trigger2 = stateno = 1350 ;Air blocking

;---------------------------------------------------------------------------
;Jump Strong Punch
[State -1, Jump Strong Punch]
type = ChangeState
value = 620
triggerall = command = "z"
trigger1 = statetype = A
trigger1 = ctrl
;trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
;trigger2 = movecontact
trigger2 = stateno = 1350 ;Air blocking

;---------------------------------------------------------------------------
;Jump Light Kick
[State -1, Jump Light Kick]
type = ChangeState
value = 630
triggerall = command = "a"
trigger1 = statetype = A
trigger1 = ctrl
trigger2 = stateno = 1350 ;Air blocking

;---------------------------------------------------------------------------
;Jump Strong Kick
[State -1, Jump Strong Kick]
type = ChangeState
value = 640
triggerall = command = "b"
trigger1 = statetype = A
trigger1 = ctrl
;trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
;trigger2 = movecontact
trigger2 = stateno = 1350 ;Air blocking

;---------------------------------------------------------------------------
;Jump Strong Kick
[State -1, Jump Strong Kick]
type = ChangeState
value = 650
triggerall = command = "c"
triggerall = command != "holddown"
trigger1 = statetype = A
trigger1 = ctrl
;trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
;trigger2 = movecontact
trigger2 = stateno = 1350 ;Air blocking

;---------------------------------------------------------------------------
;Jump Strong Kick
[State -1, Jump Strong Kick]
type = ChangeState
value = 660
triggerall = command = "c"
triggerall = command = "holddown"
trigger1 = statetype = A
trigger1 = ctrl
;trigger2 = stateno = 600 || stateno = 630 ;jump_x or jump_a
;trigger2 = movecontact
trigger2 = stateno = 1350 ;Air blocking

;----------------------------------------------------------------------------
[State -1, Super Jump ]
type = ChangeState
value = 80
trigger1 = command = "DU"
trigger1 = ctrl
trigger1 = statetype != A
;trigger2 = (stateno = 420) && (movecontact) && (command = "holdup")

